<?php
/*
* Plugin Name: Slope Widgets
* Description: Aggiungi i widget di Slope al sito web WordPress della tua struttura ricettiva! Questo plugin ti permette di mostrare la barra delle prenotazioni, i pacchetti e le promozioni tramite shortcode personalizzabili.
* Version: 3.1.0
* Author: Slope
* Author URI: https://www.slope.it/
* Text Domain: slope-widgets
* Domain Path: /languages
*/

// Inizialization
define(SLOPE_LAYOUT_HORIZONTAL, 'SLOPE_LAYOUT_HORIZONTAL');
define(SLOPE_LAYOUT_VERTICAL, 'SLOPE_LAYOUT_VERTICAL');
define(SLOPE_LAYOUT_AUTO, 'SLOPE_LAYOUT_AUTO');
define(SLOPE_PROMOTIONS_LAYOUT_ONE_CARD, 'SLOPE_PROMOTIONS_LAYOUT_ONE_CARD');
define(SLOPE_PROMOTIONS_LAYOUT_TWO_CARD, 'SLOPE_PROMOTIONS_LAYOUT_TWO_CARD');
define(SLOPE_PROMOTIONS_LAYOUT_THREE_CARD, 'SLOPE_PROMOTIONS_LAYOUT_THREE_CARD');
define(SLOPE_PROMOTIONS_LAYOUT_FOUR_CARD, 'SLOPE_PROMOTIONS_LAYOUT_FOUR_CARD');
define(SLOPE_PROMOTIONS_ALIGN_CENTER, 'SLOPE_PROMOTIONS_ALIGN_CENTER');
define(SLOPE_PROMOTIONS_ALIGN_LEFT, 'SLOPE_PROMOTIONS_ALIGN_LEFT');
define(SLOPE_PROMOTIONS_ALIGN_RIGHT, 'SLOPE_PROMOTIONS_ALIGN_RIGHT');

// Hook
add_action('admin_init', 'slope_init');
add_action('admin_menu', 'slope_add_page');
add_action('admin_enqueue_scripts', 'slope_color_picker');
add_action('admin_enqueue_scripts', 'slope_load_custom_admin');
add_action('wp_enqueue_scripts', 'slope_load_css_js');
add_action('wp_enqueue_scripts', 'slope_layout_select');
add_action('plugins_loaded', 'slope_load_textdomain');
add_action('plugin_action_links_' . plugin_basename( __FILE__ ), 'slope_action_links' );

function slope_color_picker($options) {
	wp_enqueue_style('wp-color-picker');
	wp_enqueue_script('slope-color-picker', plugins_url('js/slope-colorpicker.js', __FILE__), array('wp-color-picker'), false, true);
}

// callback css slope-widgets-admin
function slope_load_custom_admin() {
	wp_enqueue_style('slope-custom-admin', plugins_url('css/slope-widgets-admin.css', __FILE__));
	wp_enqueue_script('slope-menu-admin', plugins_url('js/slope-admin-menu.js', __FILE__));
}

function slope_load_css_js() {
	wp_enqueue_style('slope_jquery_ui_style', plugins_url('css/jquery-ui.css', __FILE__));
	wp_enqueue_style('slope_css', plugins_url('css/slope-reservations.css', __FILE__));
	wp_enqueue_style('slope_promotions_css', plugins_url('css/slope-promotions.css', __FILE__));
	wp_enqueue_script('slope_js', plugins_url('js/slope-widgets.js', __FILE__), array('jquery-ui-core', 'jquery-ui-datepicker'), false, true);
	slope_promotions_style();
	slope_promotions_title_align();
	slope_promotions_layout_select();
}

// Register the settings of Slope fields
function slope_init() {
	// Slope reservations
	register_setting('slope_options', 'slope_options', 'slope_reservations_options_validate');
	add_settings_section('reservations_section', '', 'slope_reservations_intro', 'slope_reservations_page');
	add_settings_section('reservations_secondary_section', '', 'slope_reservations_settings_docs', 'slope_reservations_page');
	add_settings_field('slope_uuid', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_button_value', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_button_value_en', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_show_children', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_children_age', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_children_age_min', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_children_age_max', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_min_days', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_calendar_color', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_text_color', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_color_stepper_button', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_button_color', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_text_button_color', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_range_button', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_select_font', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_font_size', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_layout', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_book_target', '', 'slope_reservations_page', 'reservations_section');
	add_settings_field('slope_calendar_cirlce_hover', '', 'slope_reservations_page', 'reservations_section');

	// Slope promotions
	register_setting('slope_promotions_options', 'slope_promotions_options');
	add_settings_section('promotions_section', '', 'slope_promotions_intro', 'slope_promotions_page');
	add_settings_field('slope_promotions_hide_description', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_hide_information', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_background_color', '',  'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_text_color', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_button_background_color', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_button_text_color', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_title_color', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_border_color', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_border_size', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_align_title', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_title_size', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_border_radius', '', 'slope_promotions_page', 'promotions_section');
	add_settings_field('slope_promotions_layout', '', 'slope_promotions_page', 'promotions_section');
}

// Setting of the domain of the translations
function slope_load_textdomain() {
	load_plugin_textdomain('slope-widgets', false, basename(dirname(__FILE__)) . '/languages/');
}

// Adds the emtries to the lateral menu
function slope_add_page() {
	add_menu_page(esc_html__('Impostazioni di Slope Widgets', 'slope-widgets'), 'Slope Widgets', 'slope_reservations', __FILE__, 'slope_reservations_options_page', plugins_url('images/icon.png', __FILE__));
	add_submenu_page(__FILE__, 'Slope Reservations', 'Slope Reservations', 'manage_options', 'slope_reservations', 'slope_reservations_options_page');
	add_submenu_page(__FILE__, 'Slope Promotions', 'Slope Promotions', 'manage_options', 'slope_promotions', 'slope_promotions_options_page');
}

// Add the settings link on the plugin listing page.
function slope_action_links($links) {
	$links = array_merge( array(
		'<a href="' . esc_url( admin_url( '/admin.php?page=slope_reservations' ) ) . '">' . __( 'Impostazioni', 'slope-widgets' ) . '</a>'
	), $links );
	return $links;
}

//include plugin reservations functionalities
include("slope-reservations.php");

//include plugin promotions functionalities
include("slope-promotions.php");
